function cvgrid(data, classifier_path, classifier, nfold, cstart, ctimes, cstep, ...
		seed, eps, bias)

path(path,'./read_sparse');

global y
global x
global C
global xt
global eps

[proby, probxt] = read_sparse(data, bias);
l = size(proby,1);

cd(classifier_path);
% classifier = @classifier_name

iter=1;

rand('seed', seed);
perm = randperm(l)';

C = cstart;

while iter<=ctimes,
  correct = 0; time = 0;
  for fold=1:nfold,
    global x
    global xt
    train_id = [1:floor((fold-1)*l/nfold) floor(fold*l/nfold)+1:l]';
    valid_id = [floor((fold-1)*l/nfold)+1:floor(fold*l/nfold)]';
    y = proby(perm(train_id)); 
    xt = probxt(:,perm(train_id));
    if (strcmp(func2str(classifier), 'runlrtrain_col') == 1) || (strcmp(func2str(classifier), 'runtrcgl2svm') == 1),
      x = xt';
    end
    t = cputime; w = classifier(); time = time + cputime - t;
%    tic; w = classifier(); time = time + toc;
    clear global x
    clear global xt
    validy = proby(perm(valid_id)); validxt = probxt(:,perm(valid_id));
    correct = correct + sum(validy.*(w'*validxt)'>0);
    clear validxt
  end
  fprintf(1, 'CV accuracy %f Time %f C %f\n', correct*100/l, time, C);
  
  C = C*cstep;  iter = iter+1;
end

quit
