#!/usr/bin/env python

import os, sys
from os import system
from string import find, split, atof, atoi
from time import time

# parameters
C = 1
eps_list = [1000, 400, 200, 50, 25, 10, 4, 1, 0.5, 0.1]

data_list = ['real-sim.svml', 'rcv1_test.binary']
# data_list = ['train308.scale']
#data_list = ['news20.binary']
# data_list = ['rcv1_test.binary']
classifiers_list = ['runlrtrain_row', 'svmperf']
                    
for data_name in data_list:
    print("%s" % data_name)
    train_name = "%s.tr" % (data_name)
    val_name = "%s.val" % (data_name)
    cmd = "bunzip2 %s.bz2; bunzip2 %s.bz2" % (train_name, val_name)
    system(cmd)
    model_name = "%s.model" % (data_name)
    
    outfile_name = "log/%s_svmperf.log" % (data_name)
    cmd = "wc -l %s" % (train_name) 
    result = os.popen(cmd,'r')
    train_l = atoi(split(result.readlines()[0])[0])
    print train_l
    for classifier in classifiers_list:
        for eps in eps_list:
            if classifier == 'runlrtrain_row':
                cmd = "matlab -nodisplay -r \"runlrtrain_row('%s', '%s', %s, %s)\" " % (train_name, val_name, C, eps)
            elif classifier == "svmperf":
                cmd = "../svmperf/svm_perf_learn -c %s -e %s %s %s; ../svmperf/svm_perf_classify %s %s o" % (C*train_l/100, eps, train_name, model_name, val_name, model_name)

            result = os.popen(cmd,'r')
            for line in result.readlines():
                if find(line,"Runtime in cpu-seconds") != -1:
                    print "%6.2f" % (atof(split(line)[3])),
                if find(line,"Accuracy") != -1:
                    print " %6.2f" % (atof(split(line)[2]))
    cmd = "bzip2 %s; bzip2 %s; /bin/rm %s" % (train_name, val_name, model_name)
    system(cmd)
