function runlrtrain_row(train, test, C, eps)

path(path,'../read_sparse');
path(path,'../liblr_row');
[y, xt] = read_sparse(train, 1);

param = ['-c ' num2str(C) ' -e ' num2str(eps)];
t=cputime; [w]=lrtrain(y, xt, param); t1 = cputime - t;
fprintf(1, 'Runtime in cpu-seconds: %f\n', t1);


[validy, validxt] = read_sparse(test, 1);
n = size(xt,1)-1;
validn = size(validxt,1)-1;
if validn < n,
  w = [w(1:validn); w(size(w,1))];
else
  w = [w(1:n); zeros(n-validn,1); w(size(w,1))];
end

fprintf(1, 'Accuracy : %f\n', full(100*sum(validy.*(w'*validxt)'>0)/size(validy,1)));

quit

